/**
  Generated Main Source File
*/
#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include "i2c_lib2.h"
#include "lcd_lib2.h"
#include "bme_lib2.h"
/* Low level output */
void putch(unsigned char data){
    lcd_data(data);
}
/* O[oϐA萔` */
double temp_act, pres_act, hum_act;
signed long long temp_cal;
unsigned long long pres_cal, hum_cal;
unsigned char data;
int Flag;
unsigned char Buffer[8];

/* WiFiݒpR}hf[^ */
const unsigned char Mode[] = "AT+CWMODE=1\r\n";     // Station Mode
const unsigned char Join[] = "AT+CWJAP=\"YOUR SSID\",\"YOUR PASSWORD\"\r\n";
const unsigned char Open[] = "AT+CIPSTART=\"TCP\",\"maker.ifttt.com\",80\r\n";
const unsigned char Thru[] = "AT+CIPMODE=1\r\n";    // pXX[[h
const unsigned char Send[] = "AT+CIPSEND\r\n";      // ]Jn
const unsigned char Close[] = "AT+CIPCLOSE\r\n";    // T[oڑ
const unsigned char Shut[] = "AT+CWQAP\r\n";        // Apڑ
/* GETMpbZ[W */
const unsigned char get[] = "GET ";
const unsigned char event[] = "/trigger/Send_Data";
const unsigned char secretkey[] = "/with/key/YOUR SECRET KEY";
unsigned char Data1[] = "?value1=xxxxxx";
unsigned char Data2[] = "&value2=yyyy";
unsigned char Data3[] = "&value3=zz";
const unsigned char post11[] = " HTTP/1.1\r\n";
const unsigned char post2[] = "Host: maker.ifttt.com\r\n\r\n";
const unsigned char Stop[] = "+++";     // pXX[~
/* ֐vg^Cv */
void SendStr(const unsigned char * str);
void SendCmd(const unsigned char *cmd);
void ftostring(int seisu, int shousu, float data, unsigned char *buffer);
void TMR2_Process(void);
/*
          Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();
    TMR2_SetInterruptHandler(TMR2_Process);
    
    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();
    /* LCD */
    LCDPWR_SetLow();                    // LCDdIt
    __delay_ms(1);
    LCDPWR_SetHigh();                   // LCDdI
    lcd_init();
    printf("Start IFTTT Log!");
    /* ϐ */
    Flag = 1;
    /* ZT */
    bme_init();
    bme_gettrim();    
    __delay_ms(1000);
    while (1)
    {
        // Add your application code
        /* ZTf[^擾 */
        bme_getdata();                  // ꊇ擾
        temp_cal = calib_temp(temp_raw);// xr
        pres_cal = calib_pres(pres_raw);// Cr
        hum_cal = calib_hum(hum_raw);   // xr
        /* ۂ̒lɃXP[ϊ */
        temp_act = (double)temp_cal / 100.0;
        pres_act = (double)pres_cal / 100.0;
        hum_act = (double)hum_cal / 1024.0;
        /* CAx\o */
        lcd_cmd(0x80);
        printf("T %2.1fdegC H %2.0f%%", temp_act, hum_act);
        lcd_cmd(0xC0);
        printf("P %4.0fhPa", pres_act);
        
        /******* GETM *********/
        if(Flag == 1){                  // MtOȈꍇ
            Red_SetHigh();              // ڈI
            /* T[oƐڑ */
            SendCmd(Mode);              // Station mode
            SendCmd(Join);              // APƐڑ
            __delay_ms(6000);           // APڑ҂
            SendCmd(Open);              // T[oƐڑ
            lcd_cmd(0x80);            
            printf("Open IFTTT Server");// ڑbZ[W
            __delay_ms(2000);           // T[oڑ҂ 
            Flag = 0;                   // MtOZbg
            /* Mf[^Zbg */
            ftostring(4, 1, pres_act, Data1+8);
            ftostring(2, 1, temp_act, Data2+8);        
            ftostring(2, 0, hum_act, Data3+8);            
            /* GETf[^M */
            SendCmd(Thru);              // pXX[[hݒ
            SendCmd(Send);              // MJnR}h
            __delay_ms(100);
            SendStr(get);               // "GET "
            SendStr(event);             // "/trigger/Send_Data"
            SendStr(secretkey);         // "/with/key/L[R[h";
            SendStr(Data1);             // C
            SendStr(Data2);             // x
            SendStr(Data3);             // x
            SendStr(post11);            // " HTTP/1.1\r\n"         
            SendStr(post2);             // "Host: maker.ifttt.com\r\n"; 
            __delay_ms(2000);           // T[o҂
            SendStr(Stop);              // pXX[[h
            __delay_ms(1000);           // pXX[҂
            SendCmd(Close);             // T[oڑ
            SendCmd(Shut);              // APڑ
            Red_SetLow();               // ڈIt
        }
        __delay_ms(1000);               // ZT\1bԊu
    }
}
/*******************************
 * ^C}2荞ݏ֐
 *******************************/
void TMR2_Process(void){
    Flag = 1;
}
/********************************
 * WiFi񑗐M֐
 *******************************/
void SendStr(const unsigned char * str)
{
    while(*str != 0)                    // Ō܂ŌJԂ
        EUSART_Write(*str++);           // Ms
}
/********************************
 * WiFiR}hM֐
 * x}߂
 ********************************/
void SendCmd(const unsigned char *cmd)
{
    while(*cmd != 0)                    // I[܂ŌJԂM
        EUSART_Write(*cmd++);           // Ms
    __delay_ms(1000);                   // ԐMXLbvpx
}
/***********************************
* Float當֕ϊ
* vL8ȉƂ邱
***********************************/
void ftostring(int seisu, int shousu, float data, unsigned char *buffer)
{
    int i;
    long dumy;

    if(shousu != 0)                         //肩
        buffer += seisu+shousu+1;           //Š{_
    else                                    //Ȃ̂Ƃ
        buffer += seisu + shousu;           //Š̂
    buffer--;                               //z|C^-1
    for(i=0; i<shousu; i++)                 //𐮐ɕϊ
        data = data * 10;                   //PO{
    /// dumyI[o[t[ƕϊs(WE)
    dumy = (long) (data + 0.5);             //ľܓĐɕϊ
    for(i=shousu; i>0; i--)	{           //JԂ
        *buffer =(unsigned char)(dumy % 10)+'0';//l𕶎ɕϊi[
        buffer--;                           //i[ꏊʂʂ
        dumy /= 10;                         //̌
    }
    if(shousu != 0) {                       //0Ȃ珬_Ȃ
        *buffer = '.';                      //_i[
        buffer--;                           //|C^-1
    }
    for(i=seisu; i>0; i--) {                //JԂ
        *buffer = (unsigned char)(dumy % 10)+'0';//l𕶎ɕϊi[
        buffer--;                           //|C^-1
        dumy /= 10;                         //̌
    }
}

/**
 End of File
*/